
    rawnext = next
    function next(t,k)
      local m = getmetatable(t)
      local n = m and m.__next or rawnext
      return n(t,k)
    end

 -- shows all visible internal elements of a class, including tables, methods, events & implementations
function DebugTable(class)
	if type(class) ~= "table" then
	 Turbine.Shell.WriteLine( tostring(class) .. ": (" .. type(class) .. ")");
	 return;
	end
	Turbine.Shell.WriteLine( tostring(class) .. ": (" .. type(class) .. ") " .. " : # " .. #class);
	cltb = getmetatable(class);
	if cltb then
	 for k2, v2 in pairs( cltb ) do
	  print( "(" .. k2 .. "): " .. tostring(v2) );
	 end
	end
	local mt = {
	  __next = function(t, k) return next(class, k) end
	}
	local t = setmetatable({}, mt)
--	for k,v in next, t do
	for k,v in pairs(class) do
	 Turbine.Shell.WriteLine( "(" .. k .. "): (" .. type(v) .. ") " .. tostring(v) .. " ;" );
	 if k == "__implementation" then
	  u = getmetatable(v);	v3 = v;
	  if u then
	   for k2, v2 in pairs( u ) do
	    Turbine.Shell.WriteLine( "C: (" .. k2 .. "): " .. tostring(v2) );
	    if k2 == "__index" then v3 = v2; end
	   end
	   if v3 == v then
	    if u.__index then v3 = u.__index;
	    elseif cltb and type(v) == "userdata" then
	     if cltb.__index then v3 = cltb.__index;
	     else v3 = cltb; end
	    end
	   end
	  end
	  u = v3;
	 elseif k == "__index" and not cltb and getmetatable(v) then u = getmetatable(v).__index;
	 else u = v; end
--	 Turbine.Shell.WriteLine( "(" .. k .. "): (" .. type(u) .. ") " .. tostring(u) .. " ;" );
	 if type(u) == "table" then  -- can call DebugTable(u) recursively instead
	  for k2, v2 in pairs( u ) do
	    Turbine.Shell.WriteLine( "(" .. k2 .. "): " .. tostring(v2) );
	  end
	 else
	  Turbine.Shell.WriteLine( tostring(u) );
	 end
	end
end

