import "Turbine.Debug";
import "Turbine.Utils.Class";

import "Betsiel.FilterBag";

-- debugging = true;

-- seed the random number generator
math.randomseed(Turbine.Engine.GetGameTime());
-- avoid first random number bug in some lua systems
math.random();

_dw, _dh = Turbine.UI.Display.GetSize();

local function updateScreenCoords(widget)
	local ww, wh, wx, wy;
	local changed = false;

	wx, wy = widget:GetPosition();
	ww, wh = widget:GetSize();

	if ((wx + ww) > _dw) then
		wx = _dw - ww;
		changed = true;
	end
	if ((wy + wh) > _dh) then
		wy = _dh - wh;
		changed = true;
	end

	if (wx < 0) then
		wx = 0;
		changed = true;
	end
	if (wy < 0) then
		wy = 0;
		changed = true;
	end

	if (changed) then
		widget:SetPosition(wx, wy);
	end
end

glob_loading = false;
glob_settings = {}

filterBag = FilterBagWindow();
filterBag:SetVisible( true );

options = FilterBagOptionsWindow();
options:SetVisible( false );

Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack5, false );

updateScreenCoords(options);

filterBag:SetOpacity(FilterBagOptionsWindow:GetOpac());

filterBagCommand = Turbine.ShellCommand();

-- filterBagCommand:ScriptLog();
-- if debugging then filterBagCommand:GetCallStack(); end

function filterBagCommand:Execute( command, arguments )
  if pcall( Turbine.Gameplay.LocalPlayer.GetInstance ) then
	player = Turbine.Gameplay.LocalPlayer.GetInstance();
  else
	player = Turbine.Gameplay.LocalPlayer();
  end
  local name = string.format( '%s_bags', player:GetName() );
	if ( arguments == "show" ) then
		filterBag:SetVisible( true );
	elseif ( arguments == "hide" ) then
		filterBag:SetVisible( false );
	elseif ( arguments == "toggle" ) then
		filterBag:SetVisible( not filterBag:IsVisible() );
	elseif ( arguments == "refresh" ) then
		filterBag:Refresh();
	elseif ( arguments == "options" ) then
		options:SetZOrder( 100 );
		options:SetVisible( true );
	elseif ( arguments == "sort" ) then
		FilterBagWindow:SortItems(false);
	elseif string.find(arguments, "load") then
		for word in string.gmatch(arguments, "[_%a%d\.]+") do
		  if word ~= "load" and word ~= "save" then name = word; end
		end
		FilterBagWindow:LoadItems(name);
	elseif string.find(arguments, "save") then
		for word in string.gmatch(arguments, "[_%a%d\.]+") do
		  if word ~= "load" and word ~= "save" then name = word; end
		end
		FilterBagWindow:SaveItems(name);
	elseif string.find(arguments, "%d+") then
		local opacity = tonumber( arguments )

		if ( ( opacity ~= nil ) and ( opacity > 0 ) ) then
			filterBag:SetOpacity( opacity );
		end
	else
--	if ( arguments == nil or arguments == "help" ) then
  Turbine.Shell.WriteLine("/FilterBag [toggle] [show] [hide] [refresh] [options] [sort] [save [filename]] [load [filename]]");
	end

end

function filterBagCommand:GetHelp()
	return "FilterBag show: Display FilterBag\nFilterBag hide: Hides Filterbag";
end

function filterBagCommand:GetShortHelp()
	return "Shows or hides FilterBag.";
end

Turbine.Shell.AddCommand( "tob;filterbag", filterBagCommand );

listCommandsCommand = Turbine.ShellCommand();

function listCommandsCommand:Execute( command, arguments )
	local commands = Turbine.Shell.GetCommands();

	local allCommands = ""

	for key, value in pairs(commands) do
		allCommands = allCommands .. ", " .. value
	end

	Turbine.Shell.WriteLine( allCommands )
end

Turbine.Shell.AddCommand( "listcommands", listCommandsCommand );

doomCommand = Turbine.ShellCommand();

function doomCommand:Execute( command, arguments )
	Turbine.Shell.Execute( "/plugins unload filterbag" );
end

Turbine.Shell.AddCommand( "doom", doomCommand );
